<link rel="import" href="/bower_components/polymer/polymer-element.html">
<link rel="import" href="../l1page-theme/l1page-theme.html">

<link rel="import" href="/bower_components/neon-animation/web-animations.html">
<link rel="import" href="/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/bower_components/paper-dropdown-menu/paper-dropdown-menu.html">
<link rel="import" href="/bower_components/paper-listbox/paper-listbox.html">
<link rel="import" href="/bower_components/paper-item/paper-item.html">

<link rel="import" href="../authentication-manager/authentication-manager.html">
<link rel="import" href="../toast-manager/toast-manager.html">

<!--
`<shifter-info-editor>` is not documented properly yet
-->
<dom-module id="shifter-info-editor">
  <template>
    <link rel="stylesheet" href="shifter-info-editor.css?__inline=true">
    <style include="l1page-theme"></style>

    <app-location route={{route}}></app-location>
    <app-route route={{route}} pattern="/:activeWidget" data={{urlData}} tail={{urlDataTail}}></app-route>

    <!-- thank you trumbowyg, for crashing inside an element -->
    <paper-dialog modal opened="[[_widgetActive('new-shifter-info', urlData)]]">
      <app-toolbar>
        <paper-dropdown-menu label="Type">
          <paper-listbox slot="dropdown-content"
                         selected={{newShifterInfoSelectedType}}
                         attr-for-selected=name>
            <paper-item name=cosmics>Cosmics</paper-item>
            <paper-item name=collisions>Collisions</paper-item>
            <paper-item name=short-term>Short term</paper-item>
            <paper-item name=test>Test</paper-item>
            <paper-item name=any>Any</paper-item>
          </paper-listbox>
        </paper-dropdown-menu>
        <paper-dropdown-menu label="Section">
          <paper-listbox slot="dropdown-content"
                         selected={{newShifterInfoSelectedSection}}
                         attr-for-selected=name>
            <paper-item name=general>General</paper-item>
            <paper-item name=subsystem>Subsystem</paper-item>
            <paper-item name=prescales>Prescales</paper-item>
            <paper-item name=trigger-rates>Trigger Rates</paper-item>
          </paper-listbox>
        </paper-dropdown-menu>
        <!-- <paper-input type=number label="Days valid" value={{newShifterInfoDaysValid}}></paper-input> -->
      </app-toolbar>

      <slot></slot>

      <div class="buttons">
        <paper-button primary
                      disabled="[[!_wysiwygValidInput(isLoggedIn, newShifterInfoSelectedType, newShifterInfoSelectedSection, newShifterInfoMessage, newShifterInfoLoading)]]"
                      on-click=_submitNewShifterInfo>
          [[_getSubmitMessage(urlDataTail.path)]] as [[userInfo.first_name]]
          <img src="/images/hourglass_color.gif" alt="loading..." hide$=[[!newShifterInfoLoading]]>
        </paper-button>
        <dom-if if=[[!isLoggedIn]]>
          <template>
            <p>
              you need to log in before you can submit
            </p>
            <paper-button on-click=initLogin>login</paper-button>
          </template>
        </dom-if>
        <paper-button error dialog-dismiss autofocus on-click=_closeActiveWidget>Cancel</paper-button>
      </div>

    </paper-dialog>

  </template>
</dom-module>

<script src="shifter-info-editor.js?__inline=true"></script>
